alert("SoundPool");
function SoundPool() {
    
}

SoundPool.prototype = new Multimedia();
SoundPool.prototype.load = SoundPool_load;
SoundPool.prototype.unload = SoundPool_unload;
SoundPool.prototype.play = SoundPool_play;
SoundPool.prototype.stop = SoundPool_stop;


function checkSoundID(soundID){
    if(soundID == null || soundID === '' ) {
        throwException(Widget.ExceptionTypes.INVALID_PARAMETER,'The input soundID is null');
	}
	
    if(typeof(soundID) != "number" && typeof(soundID) != "string") {
        throwException(Widget.ExceptionTypes.INVALID_PARAMETER,'The input parameter type is invalid');       
    }
    
}

function checkStreamID(streamID){
    if(streamID == null || streamID === '' ) {
        throwException(Widget.ExceptionTypes.INVALID_PARAMETER,'The input streamID is null');
	}
    if(typeof(streamID) != "number" && typeof(streamID) != "string") {
        throwException(Widget.ExceptionTypes.INVALID_PARAMETER,'The input parameter streamID type is invalid');       
    }
    
    if(isNaN(streamID) || streamID == 0) {
        throwException(Widget.ExceptionTypes.INVALID_PARAMETER,'The input streamID is invalid');
    }
}


var gSoundFiles = [];
var gSoundFileIndex = 0;

/**
 * Load the sound from the specified path.
 *
 * @param fileUrl the path to the audio file
 * @return a sound ID. This value can be used to play or unload the sound.
 */
function SoundPool_load(fileUrl) {
  alert("SoundPool_load");
 
    // Exception handling
    if(arguments.length != 1){
        throwException(Widget.ExceptionTypes.INVALID_PARAMETER,'The input parameter number is wrong');
    }
    
    if(fileUrl == null || fileUrl === "")	{
        throwException(Widget.ExceptionTypes.INVALID_PARAMETER,'The input url is null');
    }
    
    if(typeof(fileUrl) != "string") {
        throwException(Widget.ExceptionTypes.INVALID_PARAMETER,'The input parameter type is invalid');       
    }
    
    if(fileUrl.length > 255) {
        throwException(Widget.ExceptionTypes.INVALID_PARAMETER,'The input url is too long');    
    }

    var query = "fileUrl=" + Widget_encode(fileUrl);
    var aUrl = "aiduoniu023:///Multimedia/SoundPool/load?" + query;
    window.WebViewJavascriptBridge.send(aUrl, function(responseData) {
                                        log('JS got response', responseData)
                                        });

//	var query = "fileUrl=" + Widget_encode(fileUrl);
//    var aUrl = "aiduoniu023:///Multimedia/AudioPlayer/open?" + query;
//    window.WebViewJavascriptBridge.send(aUrl, function(responseData) {
//                                        
//                                        });

  gSoundFileIndex++;
  gSoundFiles[gSoundFileIndex] = fileUrl;
  var soundID ＝ gSoundFileIndex;
  return soundID;
}

/**
 * Unload a sound from a sound ID.
 *
 * Unloads the sound specified by the soundID. This is the value
 * returned by the load() function. Returns true if the sound is
 * successfully unloaded, false if the sound was already unloaded.
 *
 * @param soundID a soundID returned by the load() function
 * @return true if just unloaded, false if previously unloaded
 */
function SoundPool_unload(soundID)
{
    return true;
}

/**
 * Play a sound from a sound ID.
 *
 * Play the sound specified by the soundID. This is the value 
 * returned by the load() function. Returns a non-zero streamID
 * if successful, zero if it fails. The streamID can be used to
 * further control playback. Note that calling play() may cause
 * another sound to stop playing if the maximum number of active
 * streams is exceeded. A loop value of -1 means loop forever,
 * a value of 0 means don't loop, other values indicate the
 * number of repeats, e.g. a value of 1 plays the audio twice.
 * The playback rate allows the application to vary the playback
 * rate (pitch) of the sound. A value of 1.0 means play back at
 * the original frequency. A value of 2.0 means play back twice
 * as fast, and a value of 0.5 means playback at half speed.
 *
 * @param soundID a soundID returned by the load() function
 * @param loop loop mode (0 = no loop, -1 = loop forever)
 * @return non-zero streamID if successful, zero if failed
 */
function SoundPool_play(soundID, loopmode) {
    // Exception handling
  alert("SoundPool_play");
    if(arguments.length != 2) {
        throwException(Widget.ExceptionTypes.INVALID_PARAMETER,'The input parameter number is wrong');
    }
    
    checkSoundID(soundID);
    if(loopmode == null || loopmode === '' ) {
        throwException(Widget.ExceptionTypes.INVALID_PARAMETER,'The input loopmode is null');
	}
    if(typeof(loopmode) != "number") {
        throwException(Widget.ExceptionTypes.INVALID_PARAMETER,'The input parameter loopmode type is invalid');       
    }
    if(isNaN(loopmode) || loopmode < -1) {
        throwException(Widget.ExceptionTypes.INVALID_PARAMETER,'The input repeatTimes is invalid');
    }


  var fileUrl = gSoundFiles[soundID];
    var query = "fileUrl=" + Widget_encode(fileUrl)+"&loopmode="+ Widget_encode(loopmode);
    var aUrl = "aiduoniu023:///Multimedia/SoundPool/play?" + query;
    window.WebViewJavascriptBridge.send(aUrl, function(responseData) {
        log('JS got response', responseData)
        });

    var streamID = soundID;
	return streamID;
}


/**
 * Stop a playback stream.
 *
 * Stop the stream specified by the streamID. This
 * is the value returned by the play() function. If the stream
 * is playing, it will be stopped. It also releases any native
 * resources associated with this stream. If the stream is not
 * playing, it will have no effect.
 *
 * @param streamID a streamID returned by the play() function
 */
function SoundPool_stop(streamID) {
//    alert("Sound Pool stop!");    
    // Exception handling
    if(arguments.length != 1) {
        throwException(Widget.ExceptionTypes.INVALID_PARAMETER,'The input parameter number is wrong');
    }
	checkStreamID(streamID);
//    window.NeusoftSoundPool.stop(streamID);
    var query = "streamID=" + Widget_encode(streamID);
	var param = "Multimedia/SoundPool/stop?" + query;
	//var ret = request_webServer(param);
    
    var aUrl = "aiduoniu023:///Multimedia/SoundPool/stop?" + query;

    window.WebViewJavascriptBridge.send(aUrl, function(responseData) {
    })


}
